OGRE-Next: Ogre::v1::OldSkeletonInstance Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::OldSkeletonInstance Class Reference
Core | Component » Scene

A OldSkeletonInstance is a single instance of a Skeleton used by a world object. More...

`#include <OgreOldSkeletonInstance.h>`

Inheritance diagram for Ogre::v1::OldSkeletonInstance:
[legend]

## Public Member Functions
| OldSkeletonInstance (const SkeletonPtr &masterCopy)
| Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.
| ~OldSkeletonInstance () override
Animation * | _getAnimationImpl (const String &name, const LinkedSkeletonAnimationSource **linker=0) const override
| Internal accessor for animations (returns null if animation does not exist).
void | _initAnimationState (AnimationStateSet *animSet) override
| Initialise an animation set suitable for use with this skeleton.
void | _refreshAnimationState (AnimationStateSet *animSet) override
| Refresh an animation set suitable for use with this skeleton.
void | addLinkedSkeletonAnimationSource (const String &skelName, Real scale=1.0f) override
| Allows you to use the animations from another Skeleton object to animate this skeleton.
Animation * | createAnimation (const String &name, Real length) override
| Creates a new Animation object for animating this skeleton.
TagPoint * | createTagPointOnBone (OldBone *bone, const Quaternion &offsetOrientation=Quaternion::IDENTITY, const Vector3 &offsetPosition=Vector3::ZERO)
| Creates a TagPoint ready to be attached to a bone.
void | freeTagPoint (TagPoint *tagPoint)
| Frees a TagPoint that already attached to a bone.
Animation * | getAnimation (const String &name, const LinkedSkeletonAnimationSource **linker=0) const override
| Returns the named Animation object.
Animation * | getAnimation (unsigned short index) const override
| Gets a single animation by index.
const String & | getGroup () const override
| Gets the group which this resource is a member of.
ResourceHandle | getHandle () const override
LinkedSkeletonAnimSourceIterator | getLinkedSkeletonAnimationSourceIterator () const override
| Get an iterator over the linked skeletons used as animation sources.
const String & | getName () const override
| Gets resource name.
unsigned short | getNumAnimations () const override
| Gets the number of animations on this skeleton.
void | removeAllLinkedSkeletonAnimationSources () override
| Remove all links to other skeletons for the purposes of sharing animation.
void | removeAnimation (const String &name) override
| Removes an Animation from this skeleton.
Public Member Functions inherited from Ogre::v1::Skeleton
| Skeleton (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, don't call directly, use SkeletonManager.
| ~Skeleton () override
virtual void | _buildMapBoneByHandle (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | _buildMapBoneByName (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | _getBoneMatrices (Matrix4 *pMatrices)
| Populates the passed in array with the bone matrices based on the current position.
virtual void | _mergeSkeletonAnimations (const Skeleton *source, const BoneHandleMap &boneHandleMap, const StringVector &animations=StringVector())
| Merge animations from another Skeleton object into this skeleton.
virtual void | _notifyManualBonesDirty ()
| Internal method for marking the manual bones as dirty.
virtual void | _notifyManualBoneStateChange (OldBone *bone)
| Internal method for notifying that a bone is manual.
virtual void | _updateTransforms ()
| Updates all the derived transforms in the skeleton.
Animation * | createAnimation (const String &name, Real length) override
| Creates a new Animation object for animating this skeleton.
virtual OldBone * | createBone ()
| Creates a brand new OldBone owned by this Skeleton.
virtual OldBone * | createBone (const String &name)
| Creates a brand new OldBone owned by this Skeleton.
virtual OldBone * | createBone (const String &name, unsigned short handle)
| Creates a brand new OldBone owned by this Skeleton.
virtual OldBone * | createBone (unsigned short handle)
| Creates a brand new OldBone owned by this Skeleton.
Animation * | getAnimation (const String &name) const override
| Returns the named Animation object.
Animation * | getAnimation (unsigned short index) const override
| Gets a single animation by index.
virtual SkeletonAnimationBlendMode | getBlendMode () const
| Gets the animation blending mode which this skeleton will use.
virtual OldBone * | getBone (const String &name) const
| Gets a bone by it's name.
virtual OldBone * | getBone (unsigned short handle) const
| Gets a bone by it's handle.
virtual BoneIterator | getBoneIterator ()
| Get an iterator over all the bones in the skeleton.
ConstBoneIterator | getBoneIteratorConst () const
virtual bool | getManualBonesDirty () const
| Have manual bones been modified since the skeleton was last updated?
unsigned short | getNumAnimations () const override
| Gets the number of animations on this skeleton.
virtual unsigned short | getNumBones () const
| Returns the number of bones in this skeleton.
virtual OldBone * | getRootBone () const
| Gets the root bone of the skeleton: deprecated in favour of getRootBoneIterator.
virtual BoneIterator | getRootBoneIterator ()
| Get an iterator over the root bones in the skeleton, ie those with no parents.
bool | hasAnimation (const String &name) const override
| Returns whether this skeleton contains the named animation.
virtual bool | hasBone (const String &name) const
| Returns whether this skeleton contains the named bone.
virtual bool | hasManualBones () const
| Are there any manually controlled bones?
virtual void | optimiseAllAnimations (bool preservingIdentityNodeTracks=false)
| Optimise all of this skeleton's animations.
void | removeAnimation (const String &name) override
| Removes an Animation from this skeleton.
virtual void | reset (bool resetManualBones=false)
| Resets the position and orientation of all bones in this skeleton to their original binding position.
virtual void | setAnimationState (const AnimationStateSet &animSet)
| Changes the state of the skeleton to reflect the application of the passed in collection of animations.
virtual void | setBindingPose ()
| Sets the current position / orientation to be the 'binding pose' i.e.
virtual void | setBlendMode (SkeletonAnimationBlendMode state)
| Sets the animation blending mode this skeleton will use.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | touch ()
| 'Touches' the resource to indicate it has been used.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::v1::AnimationContainer
virtual | ~AnimationContainer ()

## Additional Inherited Members
Public Types inherited from Ogre::v1::Skeleton
typedef vector< ushort >::type | BoneHandleMap
| Map to translate bone handle from one skeleton to another skeleton.
typedef VectorIterator< BoneList > | BoneIterator
typedef vector< OldBone * >::type | BoneList
typedef ConstVectorIterator< BoneList > | ConstBoneIterator
typedef ConstVectorIterator< LinkedSkeletonAnimSourceList > | LinkedSkeletonAnimSourceIterator
typedef vector< LinkedSkeletonAnimationSource >::type | LinkedSkeletonAnimSourceList
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX

## Detailed Description

A OldSkeletonInstance is a single instance of a Skeleton used by a world object.

Remarks
  The difference between a Skeleton and a OldSkeletonInstance is that the Skeleton is the 'master' version much like Mesh is a 'master' version of Entity. Many OldSkeletonInstance objects can be based on a single Skeleton, and are copies of it when created. Any changes made to this are not reflected in the master copy. The exception is animations; these are shared on the Skeleton itself and may not be modified here.

## Constructor & Destructor Documentation

## ◆ OldSkeletonInstance()

Ogre::v1::OldSkeletonInstance::OldSkeletonInstance | ( | const SkeletonPtr & | masterCopy | ) |

Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.

## ◆ ~OldSkeletonInstance()

Ogre::v1::OldSkeletonInstance::~OldSkeletonInstance | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getAnimationImpl()

Animation * Ogre::v1::OldSkeletonInstance::_getAnimationImpl | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = 0 ) const
| overridevirtual

Internal accessor for animations (returns null if animation does not exist).

Reimplemented from Ogre::v1::Skeleton.

## ◆ _initAnimationState()

void Ogre::v1::OldSkeletonInstance::_initAnimationState | ( | AnimationStateSet * | animSet | ) |
| overridevirtual

Initialise an animation set suitable for use with this skeleton.

Remarks
  Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::v1::Skeleton.

## ◆ _refreshAnimationState()

void Ogre::v1::OldSkeletonInstance::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |
| overridevirtual

Refresh an animation set suitable for use with this skeleton.

Remarks
  Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::v1::Skeleton.

## ◆ addLinkedSkeletonAnimationSource()

void Ogre::v1::OldSkeletonInstance::addLinkedSkeletonAnimationSource | ( | const String & | skelName,
|  | Real | scale = 1.0f )
| overridevirtual

Allows you to use the animations from another Skeleton object to animate this skeleton.

Remarks
  If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters

  skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

Reimplemented from Ogre::v1::Skeleton.

## ◆ createAnimation()

Animation * Ogre::v1::OldSkeletonInstance::createAnimation | ( | const String & | name,
|  | Real | length )
| overridevirtual

Creates a new Animation object for animating this skeleton.

Remarks
  This method updates the reference skeleton, not just this instance!

Parameters

  name | The name of this animation
  length | The length of the animation in seconds

Implements Ogre::v1::AnimationContainer.

## ◆ createTagPointOnBone()

TagPoint * Ogre::v1::OldSkeletonInstance::createTagPointOnBone | ( | OldBone * | bone,
|  | const Quaternion & | offsetOrientation = Quaternion::IDENTITY,
|  | const Vector3 & | offsetPosition = Vector3::ZERO )

Creates a TagPoint ready to be attached to a bone.

References Ogre::Quaternion::IDENTITY, and Ogre::Vector3::ZERO.

## ◆ freeTagPoint()

void Ogre::v1::OldSkeletonInstance::freeTagPoint | ( | TagPoint * | tagPoint | ) |

Frees a TagPoint that already attached to a bone.

## ◆ getAnimation() [1/2]

Animation * Ogre::v1::OldSkeletonInstance::getAnimation | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = 0 ) const
| overridevirtual

Returns the named Animation object.

Reimplemented from Ogre::v1::Skeleton.

## ◆ getAnimation() [2/2]

Animation * Ogre::v1::OldSkeletonInstance::getAnimation | ( | unsigned short | index | ) | const
| overridevirtual

Gets a single animation by index.

Implements Ogre::v1::AnimationContainer.

## ◆ getGroup()

const String & Ogre::v1::OldSkeletonInstance::getGroup | ( |  | ) | const
| overridevirtual

Gets the group which this resource is a member of.

Reimplemented from Ogre::Resource.

## ◆ getHandle()

ResourceHandle Ogre::v1::OldSkeletonInstance::getHandle | ( |  | ) | const
| overridevirtual

Reimplemented from Ogre::Resource.

## ◆ getLinkedSkeletonAnimationSourceIterator()

LinkedSkeletonAnimSourceIterator Ogre::v1::OldSkeletonInstance::getLinkedSkeletonAnimationSourceIterator | ( |  | ) | const
| overridevirtual

Get an iterator over the linked skeletons used as animation sources.

Reimplemented from Ogre::v1::Skeleton.

## ◆ getName()

const String & Ogre::v1::OldSkeletonInstance::getName | ( |  | ) | const
| overridevirtual

Gets resource name.

Reimplemented from Ogre::Resource.

## ◆ getNumAnimations()

unsigned short Ogre::v1::OldSkeletonInstance::getNumAnimations | ( |  | ) | const
| overridevirtual

Gets the number of animations on this skeleton.

Implements Ogre::v1::AnimationContainer.

## ◆ removeAllLinkedSkeletonAnimationSources()

void Ogre::v1::OldSkeletonInstance::removeAllLinkedSkeletonAnimationSources | ( |  | ) |
| overridevirtual

Remove all links to other skeletons for the purposes of sharing animation.

Reimplemented from Ogre::v1::Skeleton.

## ◆ removeAnimation()

void Ogre::v1::OldSkeletonInstance::removeAnimation | ( | const String & | name | ) |
| overridevirtual

Removes an Animation from this skeleton.

Remarks
  This method updates the reference skeleton, not just this instance!

Implements Ogre::v1::AnimationContainer.

The documentation for this class was generated from the following file:

- OgreOldSkeletonInstance.h